import src


class ProtectSuperior(src.quests.MetaQuestSequence):
    type = "ProtectSuperior"

    def __init__(self, description="protect superior", toProtect=None):
        questList = []
        super().__init__(questList)
        self.metaDescription = description

        self.lastSuperiorPos = None
        self.delegatedTask = False

    def triggerCompletionCheck(self,character=None):
        return False

    def checkDoRecalc(self,character):
        if character.superior.dead:
            self.fail()
            return

        if character.getTerrain() != character.superior.getTerrain():
            return

        if self.lastSuperiorPos != self.getSuperiorsTileCoordinate(character):
            self.clearSubQuests()

    def getQuestMarkersTile(self,character):
        result = super().getQuestMarkersTile(character)
        result.append((self.getSuperiorsTileCoordinate(character),"target"))
        return result

    def getSuperiorsTileCoordinate(self,character):
        return character.superior.getBigPosition()

    def solver(self, character):
        character.timeTaken += 0.1
        if not (character.superior or character.superior.dead):
            self.fail()
            return True

        """
        if self.delegatedTask == False and character.rank < 6:
            command = ".QSNProtectSuperior\n ."
            character.runCommandString(command)
            self.delegatedTask = True
            return
        """

        self.checkDoRecalc(character)

        if self.subQuests:
            return super().solver(character)

        if character.getTerrain() != character.superior.getTerrain():
            targetTerrain = character.superior.getTerrain()
            if not targetTerrain:
                character.timeTaken += 0.5
                return None
            pos = (targetTerrain.xPosition,targetTerrain.yPosition,0)
            self.addQuest(src.quests.questMap["GoToTerrain"](targetTerrain=pos))
            return None

        if character.container == character.superior.container and self.getSuperiorsTileCoordinate(character) == character.getBigPosition():
            if character.container.getEnemiesOnTile(character):
                self.addQuest(src.quests.questMap["Fight"]())
                return None
            character.runCommandString("5.")
            return None

        self.lastSuperiorPos = self.getSuperiorsTileCoordinate(character)
        if self.lastSuperiorPos[0] not in (0,14,) and self.lastSuperiorPos[1] not in (0,14,):
            self.addQuest(src.quests.questMap["GoToTile"](targetPosition=self.lastSuperiorPos,paranoid=True))
            return None
        return None

src.quests.addType(ProtectSuperior)
